GIT-DIFF(1)

NAME
git-diff - Show changes between commits, commit and working tree, etc

SYNOPSIS
git-diff [<common diff options>] <commit>{0,2} [--] [<path>...]

DESCRIPTION
Show changes between two trees, a tree and the working tree, a tree and the index file, or the index file and the working tree.

git-diff [--options] [--] [<path>...]
    This form is to view the changes you made relative to the index (staging area for the next commit). In other words, the differences are what you _could_ tell git to further add to the index but you still haven't. You can stage these changes by using git-add(1). If exactly two paths are given, and at least one is untracked, compare the two files / directories. This behavior can be forced by --no-index.

git-diff [--options] --cached [<commit>] [--] [<path>...]
    This form is to view the changes you staged for the next commit relative to the named <commit>. Typically you would want comparison with the latest commit, so if you do not give <commit>, it defaults to HEAD.

git-diff [--options] <commit> [--] [<path>...]
    This form is to view the changes you have in your working tree relative to the named <commit>. You can use HEAD to compare it with the latest commit, or a branch name to compare with the tip of a different branch.

git-diff [--options] <commit> <commit> [--] [<path>...]
    This is to view the changes between two arbitrary <commit>.

git-diff [--options] <commit>..<commit> [--] [<path>...]
    This is synonymous to the previous form. If <commit> on one side is omitted, it will have the same effect as using HEAD instead.

git-diff [--options] <commit>...<commit> [--] [<path>...]
    This form is to view the changes on the branch containing and up to the second <commit>, starting at a common ancestor of both <commit>. "git-diff A...B" is equivalent to "git-diff $(git-merge-base A B) B". You can omit any one of <commit>, which has the same effect as using HEAD instead. Just in case if you are doing something exotic, it should be noted that all of the <commit> in the above description, except for the last two forms that use ".." notations, can be any <tree-ish>. For a more complete list of ways to spell <commit>, see "SPECIFYING REVISIONS" section in git-rev-parse(1). However, "diff" is about comparing two _endpoints_, not ranges, and the range notations ("<commit>..<commit>" and "<commit>...<commit>") do not mean a range as defined in the "SPECIFYING RANGES" section in git-rev-parse(1).

OPTIONS

-p  Generate patch (see section on generating patches)

-u  Synonym for "-p".

-U<n>
    Shorthand for "--unified=<n>".

--unified=<n>
    Generate diffs with <n> lines of context instead of the usual three. Implies "-p".

--raw
    Generate the raw format.

--patch-with-raw
    Synonym for "-p --raw".

--stat[=width[,name-width]]
    Generate a diffstat. You can override the default output width for 80-column terminal by "--stat=width". The width of the filename part can be controlled by giving another width to it separated by a comma.

--numstat
    Similar to --stat, but shows number of added and deleted lines in decimal notation and pathname without abbreviation, to make it more machine friendly. For binary files, outputs two - instead of saying 0 0.

--shortstat
    Output only the last line of the --stat format containing total number of modified files, as well as number of added and deleted lines.

--summary
    Output a condensed summary of extended header information such as creations, renames and mode changes.

--patch-with-stat
    Synonym for "-p --stat".

-z  NUL-line termination on output. This affects the --raw output field terminator. Also output from commands such as "git-log" will be delimited with NUL between commits.

--name-only
    Show only names of changed files.

--name-status
    Show only names and status of changed files.

--color
    Show colored diff.

--no-color
    Turn off colored diff, even when the configuration file gives the default to color output.

--color-words
    Show colored word diff, i.e. color words which have changed.

--no-renames
    Turn off rename detection, even when the configuration file gives the default to do so.

--check
    Warn if changes introduce trailing whitespace or an indent that uses a space before a tab.

--full-index
    Instead of the first handful characters, show full object name of pre- and post-image blob on the "index" line when generating a patch format output.

--binary
    In addition to --full-index, output "binary diff" that can be applied with "git apply".

--abbrev[=<n>]
    Instead of showing the full 40-byte hexadecimal object name in diff-raw format output and diff-tree header lines, show only handful hexdigits prefix. This is independent of --full-index option above, which controls the diff-patch output format. Non default number of digits can be specified with --abbrev=<n>.

-B  Break complete rewrite changes into pairs of delete and create.

-M  Detect renames.

-C  Detect copies as well as renames. See also --find-copies-harder.

--diff-filter=[ACDMRTUXB*]
    Select only files that are Added (A), Copied (C), Deleted (D), Modified (M), Renamed (R), have their type (mode) changed (T), are Unmerged (U), are Unknown (X), or have had their pairing Broken (B). Any combination of the filter characters may be used. When * (All-or-none) is added to the combination, all paths are selected if there is any file that matches other criteria in the comparison; if there is no file that matches other criteria, nothing is selected.

--find-copies-harder
    For performance reasons, by default, -C option finds copies only if the original file of the copy was modified in the same changeset. This flag makes the command inspect unmodified files as candidates for the source of copy. This is a very expensive operation for large projects, so use it with caution. Giving more than one -C option has the same effect.

-l<num>
    -M and -C options require O(n^2) processing time where n is the number of potential rename/copy targets. This option prevents rename/copy detection from running if the number of rename/copy targets exceeds the specified number.

-S<string>
    Look for differences that contain the change in <string>.

--pickaxe-all
    When -S finds a change, show all the changes in that changeset, not just the files that contain the change in <string>.

--pickaxe-regex
    Make the <string> not a plain string but an extended POSIX regex to match.

-O<orderfile>
    Output the patch in the order specified in the <orderfile>, which has one shell glob pattern per line.

-R  Swap two inputs; that is, show differences from index or on-disk file to tree contents.

--text
    Treat all files as text.

-a  Shorthand for "--text".

--ignore-space-at-eol
    Ignore changes in white spaces at EOL.

--ignore-space-change
    Ignore changes in amount of white space. This ignores white space at line end, and consider all other sequences of one or more white space characters to be equivalent.

-b  Shorthand for "--ignore-space-change".

--ignore-all-space
    Ignore white space when comparing lines. This ignores difference even if one line has white space where the other line has none.

-w  Shorthand for "--ignore-all-space".

--exit-code
    Make the program exit with codes similar to diff(1). That is, it exits with 1 if there were differences and 0 means no differences.

--quiet
    Disable all output of the program. Implies --exit-code.

--ext-diff
    Allow an external diff helper to be executed. If you set an external diff driver with gitlink:gitattributes(5), you need to use this option with gitlink:git-log(1) and friends.

--no-ext-diff
    Disallow external diff drivers. For more detailed explanation on these common options, see also [1]diffcore documentation.

<path>...
    The <paths> parameters, when given, are used to limit the diff to the named paths (you can give directory names and get diff for all files under them).

EXAMPLES

Various ways to check your working tree

    $ git diff            (1)
    $ git diff --cached   (2)
    $ git diff HEAD       (3)

    1. Changes in the working tree not yet staged for the next commit.
    2. Changes between the index and your last commit; what you would be committing if you run "git commit" without "-a" option.
    3. Changes in the working tree since your last commit; what you would be committing if you run "git commit -a"

Comparing with arbitrary commits

    $ git diff test            (1)
    $ git diff HEAD -- ./test  (2)
    $ git diff HEAD^ HEAD      (3)

    1. Instead of using the tip of the current branch, compare with the tip of "test" branch.
    2. Instead of comparing with the tip of "test" branch, compare with the tip of the current branch, but limit the comparison to the file "test".
    3. Compare the version before the last commit and the last commit.

Comparing branches

    $ git diff topic master    (1)
    $ git diff topic..master   (2)
    $ git diff topic...master  (3)

    1. Changes between the tips of the topic and the master branches.
    2. Same as above.
    3. Changes that occured on the master branch since when the topic branch was started off it.

Limiting the diff output

    $ git diff --diff-filter=MRC            (1)
    $ git diff --name-status                (2)
    $ git diff arch/i386 include/asm-i386   (3)

    1. Show only modification, rename and copy, but not addition nor deletion.
    2. Show only names and the nature of change, but not actual diff output.
    3. Limit diff output to named subtrees.

Munging the diff output

    $ git diff --find-copies-harder -B -C  (1)
    $ git diff -R                          (2)

    1. Spend extra cycles to find renames, copies and complete rewrites (very expensive).
    2. Output diff in reverse.

AUTHOR
Written by Linus Torvalds <torvalds@osdl.org>

DOCUMENTATION
Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>.

GIT
Part of the git(7) suite

REFERENCES

1. diffcore documentation
    diffcore.html